<style>
  .table-cell-links {
    width: 60px;
  }
  .table-cell-links a {
    padding: 2px 1px;
  }

  /*** custom css only popup ***/
  /*.columnSelectorWrapper {
    position: relative;
    margin: 10px 0;
    display: inline-block;
  }
  .columnSelector, .hidden {
    display: none;
  }
  #colSelect1:checked + label {
  }
  #colSelect1:checked ~ #columnSelector {
    display: block;
  }
  .columnSelector {
    width: 200px;
    position: absolute;
    top: 30px;
    padding: 10px;
    background: #fff;
    border: #99bfe6 1px solid;
    border-radius: 5px;
  }
  .columnSelector label {
    display: block;
  }
  .columnSelector label:nth-child(1) {
    border-bottom: #99bfe6 solid 1px;
    margin-bottom: 5px;
  }
  .columnSelector input {
    margin-right: 5px;
  }
  .columnSelector .disabled {
    color: #ddd;
  }*/

  .tablesorter-sticky-visible {
    top: 52px !important;
  }

  #collapse-columns {
    /*display: block;*/
    width: 200px;
    position: absolute;
    top: 31px;
    padding: 5px;
    background: #fff;
    border: #99bfe6 1px solid;
    border-radius: 3px;
    font-size: 12px;
    line-height: 24px;
    font-weight: normal;
  }

  .column-block {
    position: relative;
    display: inline-block;
    z-index: 1;
  }
</style>

<!--
<%# if @pagy && @pagy.count > @pagy.items %>
  <div class="row">
    <div class="col-sm-6">
      <%#= pagy_info(@pagy).html_safe %>
      <%#= pagy_bootstrap_nav_js(@pagy).html_safe %>
      <%#= pagy_bootstrap_combo_nav_js(@pagy).html_safe %>
    </div>
    <div class="col-sm-6 pagy-selector">
      <%#= pagy_items_selector_js(@pagy).html_safe %>
    </div>
  </div>
<%# end %>
-->

<% nb_columns = 0
   nb_first_column = 0
%>
<table id='<%= show_buttons ? "table-tasks" : ""%>' data-toggle="tablesort"  class='tablesorter tablesorter-blue table-<%=@task_columns_type%>'>
<!-- <table id='table-tasks' data-toggle="tablesort"  class='tablesorter tablesorter-blue'> -->
  <thead>
    <tr class='hasSpan'> <!-- class="tablesorter-ignoreRow"> -->
      <% if @set_check_box_email %>
        <th style='width: 30px;' data-sorter="false" data-filter="false"></th>
        <% nb_columns += 1
           nb_first_column += 1
        %>
      <% end %>

      <% unless plan_options[:rcas] || plan_options[:type_plan] == 'rca' %>
        <th style="width: 176px;" class="">RCA</th>
        <% nb_columns += 1
           nb_first_column += 1
        %>
      <% end %>

      <% if show_column('object', 'ref') %>
        <th class='task-ref' data-column-selector="disable"><%= Tools::Task.human_attribute_name :ref %></th>
        <% nb_columns += 1
           nb_first_column += 1
        %>
      <% end %>
      <th class='task-title' data-column-selector="disable"><%= Tools::Task.human_attribute_name :name %></th>

      <% ['advancement', 'responsible_action', 'responsible_rca', 'result', 'priority', 'date_due', 'date_completion'].each do |column_name| %>
        <% str, nb_columns = task_column_object_title(column_name, nb_columns) %>
        <%= str.html_safe %>
      <% end %>

      <!-- Matrix Status -->
      <% if plan_options[:matrix] %>
        <% str, nb_columns = task_column_matrix_title('matrix_status', nb_columns) %>
        <%= str.html_safe %>
      <% end %>

      <!-- TaskValidation -->
      <% if plan_options[:validation] %>
        <% str, nb_columns = task_column_validation_title('status', nb_columns) %>
        <%= str.html_safe %>
      <% end %>

      <!-- Efficacity -->
      <% if plan_options[:efficacity] %>

        <% ['check_status', 'percentage', 'date_due_check', 'date_done_check'].each do |column_name| %>
          <% str, nb_columns = task_column_efficacity_title(column_name, nb_columns) %>
          <%= str.html_safe %>
        <% end %>
      <% end %>

      <% if show_buttons %>
        <th data-column-selector="disable"class="filter-false sort-false"></th>
        <% nb_columns += 1 %>
      <% end %>
    </tr>
  </thead>
  <!-- Pour permettre la mise en forme du tableau même si aucune action à afficher -->
  <tbody></tbody>

  <% if plan_options[:blocks] %>
    <% back_block = 0 %>
  <% else %>
    <tbody>
  <% end %>

  <% if plan_options[:rcas]
       back_rca = 0
     end %>

  <!-- SI TRI PAR CAUSE => SEUL CAS OU ON CHARGE ICI LES TASKS / SINON TOUT DANS LE CONTROLLEUR -->
  <% @tools_causes, _causes_colors = plan_options[:causes] && @rca ? causes_with_colors(@rca, @step_tool.tool_reference) : [[1],[]] %>
  <% @tools_causes.each do |tools_cause| %>

    <% if plan_options[:causes] %>
      <tbody class="tablesorter-no-sort">
      <tr class='hasSpan'><th colspan="<%=nb_columns+1%>" class='task-cause-line'>
        <% cause_presenter = Tools::CausePresenter.new(tools_cause, nil) %>
        <%= tools_cause.dec_level.html_safe + tools_cause.name_with_level %>
        <%= icon_status(tools_cause, 'status') %>
        <%= cause_presenter.cause_icon_status_editable if show_buttons && policy(tools_cause).edit_status? %>

        <% @tools_cause = tools_cause %>
      </th></tr>
      </tbody>
      <% if plan_options[:blocks_column] == 'matrix_status'
           @tools_tasks = Tools::TaskQuery.relation.cause_tasks_by_matrix_status(tools_cause.id, task_options)
         else
           @tools_tasks = Tools::TaskQuery.relation.cause_tasks_by_column(tools_cause.id, task_options, plan_options[:blocks_column])
         end
      %>
    <% end %>

    <!-- BOUCLE SUR LES TASKS -->
    <% list_des_tasks = @tools_tasks.includes(:responsible_rca, :responsible_action, :efficacity, :matrix_stat)
       list_des_tasks.sort_by_ancestry(list_des_tasks).each do |tools_task| %>

      <!-- SI TRI PAR RCA : AFFICHAGE DE LA LIGNE DU RCA -->
      <% if plan_options[:rcas] && tools_task.rca_id != back_rca %>
        <%
         if tools_task.rca.nil?
           # binding.pry
         end

         rca = tools_task.rca %>
        <tbody class="tablesorter-no-sort">
          <tr class='hasSpan'><th colspan="<%=nb_columns+1%>" class='task-cause-line'>
            <%= link_to ("RCA #{rca.reference} - "+rca.title+'  '+fa_icon_edit).html_safe, edit_rca_path(rca) %>
            <%= ' - ' + rca.methodology.name %>
          </th></tr>
        </tbody>
        <% back_block = 0
           back_rca = tools_task.rca_id
        %>
      <% end %>
      <!-- END TRI PAR RCA -->

      <!-- SI TRI PAR BLOCK : AFFICHAGE DE LA LIGNE DU BLOCK -->
      <% if plan_options[:blocks] %>
        <% if tools_task.send(plan_options[:blocks_column]) != back_block %>
          <% if back_block != 0 %>
            </tbody>
          <% end %>
          <% back_block = tools_task.send(plan_options[:blocks_column]) %>
          <% # back_block = 'none' unless back_block %>
          <tbody class="tablesorter-no-sort">
            <tr class='hasSpan'><th colspan="<%=nb_columns+1%>" class='task-block-line'>
              <%#= t(back_block.tableize, scope: [:activerecord, :models]) %>
              <%= t((back_block||'none'), scope: [:simple_form, :options, :tools_task, plan_options[:blocks_column]]) %>
            </th></tr>
          </tbody>
          <tbody>
        <% end %>
      <% end %>
      <!-- END TRI PAR BLOCK -->

      <!-- ON AFFICHE LA TASK ET SES SOUS-TASKS -->
      <%= render partial: 'tools/tasks/task_line', locals: {rca: @rca, tools_task: tools_task, plan_options: plan_options, show_buttons: show_buttons} %>
    <% end %>
  <% end %>
  </tbody>
</table>

<script>
  $(function() {
    $('#table-tasks').tablesorter({
      theme : 'blue',
      // sortList  : [[0, 0]],
      cssChildRow : "tablesorter-childRow",
      // debug: "core saveSort",
      widgets : [ 'filter', 'columnSelector', 'stickyHeaders'], // "saveSort", "filter" , "pager" ],
      cssInfoBlock : "tablesorter-no-sort",
      // duplicateSpan : false,
      widgetOptions : {
        // output default: '{page}/{totalPages}'
        // possible variables: {page}, {totalPages}, {filteredPages}, {startRow}, {endRow}, {filteredRows} and {totalRows}
        // pager_output: '{startRow} - {endRow} / {filteredRows} ({totalRows})',
        // pager_removeRows: false,

        filter_childRows  : true,
        // filter_childByColumn : true,
        filter_cssFilter  : 'tablesorter-filter', // class name applied to filter row and each input
        filter_startsWith : false, // search from beginning
        filter_ignoreCase : true,
        filter_saveFilters : true,
        saveSort : true,

        filter_external : '.search-tasks',
        filter_reset: '.reset-tasks',

        // filter_columnFilters: false,
        filter_columnFilters : true,
        filter_functions : { // https://mottie.github.io/tablesorter/docs/example-widget-filter-custom.html
          // // 0 : true,
          <%=nb_first_column+1%>: {
            "not started" : function(e, n, f, i, $r, c, data) { return e === '0'; },
            "not closed" :  function(e, n, f, i, $r, c, data) { return /^[0-3]/.test(e); },
            "closed" :      function(e, n, f, i, $r, c, data) { console.log("-"+e+"-"); return /^[4]/.test(e); } // console.log(e);
          },
          // 5 :  {
          //   "Low" : function(e, n, f, i, $r, c, data) { console.log(e); return /^[0]/.test(e); },
          //   "Medium" :  function(e, n, f, i, $r, c, data) { return /^[1]/.test(e); },
          //   "High" :      function(e, n, f, i, $r, c, data) { return /^[2]/.test(e); } // console.log(e);
          // },
          <%=nb_first_column+5%>: true,
          <%=nb_first_column+6%>: {
            "Late" : function(e, n, f, i, $r, c, data) { console.log(e); return /^[Ll]/.test(e); },
            "Not late" :  function(e, n, f, i, $r, c, data) { return /^[Ii]/.test(e); }
          }
          //,
          //<%#=nb_first_column+8%>: true
        },

        /*
        // Column Selector
        columnSelector_container : $('#columnSelector'),
        // column status, true = display, false = hide
        // disable = do not display on list
        columnSelector_columns : {
          0: 'disable' // set to disabled; not allowed to unselect it
        },
        // remember selected columns (requires $.tablesorter.storage)
        columnSelector_saveColumns: true,

        // container layout
        columnSelector_layout : '<label><input type="checkbox">{name}</label>',
        // layout customizer callback called for each column
        // function($cell, name, column) { return name || $cell.html(); }
        columnSelector_layoutCustomizer : null,
        // data attribute containing column name to use in the selector container
        columnSelector_name  : 'data-selector-name',

        // Responsive Media Query settings
        // enable/disable mediaquery breakpoints
        columnSelector_mediaquery: false,

        // class name added to checked checkboxes - this fixes an issue with Chrome not updating FontAwesome
        // applied icons; use this class name (input.checked) instead of input:checked
        columnSelector_cssChecked : 'checked',

        // class name added to rows that have a span (e.g. grouping widget & other rows inside the tbody)
        columnSelector_classHasSpan : 'hasSpan',

        // event triggered when columnSelector completes
        columnSelector_updated : 'columnUpdate'
        */
      }
    });

    // function task_toggle_child_rows_do(elem, value = null) {
    //   if (value != null) {
    //     // elem.closest('tr').nextUntil('tr:not(.tablesorter-childRow)').find('td').toggle(value);
    //     if (value == true) {
    //       elem.closest('tr').nextUntil('tr:not(.tablesorter-childRow)').find('td').css('display', '')
    //     }
    //     else {
    //       elem.closest('tr').nextUntil('tr:not(.tablesorter-childRow)').find('td').css('display', 'none')
    //     }
    //   }
    //   else {
    //     elem.closest('tr').nextUntil('tr:not(.tablesorter-childRow)').find('td').toggle();
    //   }
    //   // in v2.5.12, the parent row now has the class tablesorter-hasChildRow
    //   // so you can use this code as well
    //   // $(this).closest('tr').nextUntil('tr.tablesorter-hasChildRow').find('td').toggle();
    // }

    // // $('#table-tasks').delegate('.task-toggle', 'click' ,function() {
    // $('.task-toggle').on('click', function() {
    //   console.log('CLICK TASK TOGGLE ' + $(this).attr('id'));

    //   Packs.tasks_pack.tasks_test();

    //   // save open/close state in localstorage
    //   if (localStorage.getItem($(this).attr('id')) == null) {
    //     localStorage.setItem($(this).attr('id'), 'close');
    //     task_toggle_child_rows_do($(this), false);
    //   }
    //   else {
    //     localStorage.removeItem($(this).attr('id'));
    //     task_toggle_child_rows_do($(this), true);
    //   }

    //   return false;
    // });

    // // Local storage for open/close actions/sub-actions
    // function set_open_close_states_local_storage(elem_name) {
    //   console.log('Function OPEN CLOSE ACTIONS=====================>');
    //   $(elem_name).each(function(){
    //     var checkb = localStorage.getItem($(this).attr('id'));
    //     console.log("Set open/close ===========+++++++> " + elem_name);
    //     console.log($(this).attr('id'))
    //     if (checkb == 'close') {
    //       console.log(checkb)
    //       task_toggle_child_rows_do($(this), false);
    //     }
    //   });
    // }

    // function set_open_close_all_actions(oc) {
    //   if (oc == 'close') {
    //     $('.task-toggle').each(function(){
    //       task_toggle_child_rows_do($(this), false);
    //       localStorage.setItem($(this).attr('id'), 'close');
    //     });
    //   }
    //   else {
    //     $('.task-toggle').each(function(){
    //       task_toggle_child_rows_do($(this), true);
    //       localStorage.removeItem($(this).attr('id'));
    //     });
    //   }
    // // }

    // $('#tasks-open-all').click(function(){
    //   set_open_close_all_actions('open');
    // });

    // $('#tasks-close-all').click(function(){
    //   set_open_close_all_actions('close');
    // });

    // set_open_close_states_local_storage('.task-toggle')

    // Packs.tasks_pack.tasks_ancestry();

    // Avancements
    $('.jquery-circle-p').circleProgress({});


    /* // Columns : check-box actions
    $('.column-check').on('click', function(event) {
      // event.preventDefault();
      console.log('CLICK!');
      column_title = $(this).attr('column-title')
      column_index = $(this).attr('column-index')
      column_block = $(this).attr('column-block')
      show_hide = true

      console.log("Set column "+column_title + " Index = " + column_index);

      $("th[column-title='"+column_title+"']").each(function() {
        if ($(this).css('display') == 'none') {
          console.log('SHOW '+column_title);
          $(this).css('display', '');
          $(this).closest('table').find("td:nth-child("+column_index+")").css('display', '');
        }
        else {
          console.log('HIDE '+column_title);
          $(this).css('display', 'none');
          $(this).closest('table').find("td:nth-child("+column_index+")").css('display', 'none');
          show_hide = false
        }
      });


      let url = "<%= users_admin_update_pa_options_path %>";
      let datas = {};
      datas['pa_type'] = "<%= @task_columns_type %>";
      datas['column'] = column_title;
      datas['block'] = column_block;
      datas['value'] = show_hide;

      $.ajax({
        url: url,
        type: 'PATCH',
        data: datas,
        dataType: 'script',
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
        success: function(data) {
          console.log('OK.');
        }
      });
    });

    // Columns : initialization => hide columns.
    columns_hide = JSON.parse('= raw @columns_hide || [] %>');
    columns_hide.forEach(function(col) {
      console.log("===> hide column "+col);
      $(".column-check[column-title='"+col+"']").each(function() {
        column_title = col
        column_index = $(this).attr('column-index')
        column_block = $(this).attr('column-block')
        show_hide = true
        console.log("INDEX = "+column_index);

        $("th[column-title='"+column_title+"']").each(function() {
          // console.log('HIDE '+column_title);
          $(this).css('display', 'none');
          $(this).closest('table').find("td:nth-child("+column_index+")").css('display', 'none');
        });
      })
    });
    */

    // Columns => save user options
    $('.column-check').on('click', function(event) {
      console.log('CLICK!');
      column_title = $(this).attr('column-title')
      column_block = $(this).attr('column-block')

      console.log("Set column "+column_title);

      show_hide = true
      if( $(this).is(':checked') ){
        show_hide = true
      } else {
        show_hide = false
      }

      let url = "<%= users_admin_update_pa_options_path %>";
      let datas = {};
      datas['pa_type'] = "<%= @task_columns_type %>";
      datas['column'] = column_title;
      datas['block'] = column_block;
      datas['value'] = show_hide;

      $.ajax({
        url: url,
        type: 'PATCH',
        data: datas,
        dataType: 'script',
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
        success: function(data) {
          console.log('OK.');
        }
      });
    });
  });
</script>
